import { MutableRefObject } from 'react';
export interface DisplayMode {
    fullScreen: boolean;
    preview: boolean;
    editorPreview: boolean;
}
declare type ToggleFullScreen = (fullScreen?: boolean) => boolean;
declare type TogglePreview = (preview?: boolean) => boolean;
declare type ToggleEditorPreview = (editorPreview?: boolean) => boolean;
declare const _default: (state?: Partial<DisplayMode> | undefined, editorPreviewEnableFullScreen?: boolean) => [MutableRefObject<DisplayMode>, ToggleFullScreen, TogglePreview, ToggleEditorPreview];
export default _default;
